#include <win>
using namespace Win;

#include <iostream>
using namespace std;

#include "../Images/tools.h"
#include "../Images/lmeds.h"
#include "../Images/image.h"

// Variable globales (pour etre vues de estimator et residual)
// Vieux style C!
const int N=15;
const int Diam=8;


//Nombre de points de Harris voulus (infrieur  1000)
const int nbharris=50;
double X[N],Y[N],Z[N],T[N];
//	Z[i]	49.000000000000000	double


/*
Points de Harris :

Prend en entre le chemin d'un fichier image, le nombre
de points de Harris voulu, et l'cartement minimal entre
ces points.
Elle se restreint aux points d'abscisse comprise entre
imin et imax, et d'ordonne comprise entre ymin et ymax.
Renvoie une image de largeur double de l'image de dpart,
avec :
- sur la gauche, une image avec des 255 pour chaque
point de Harris, et 0 sinon.
- sur la droite, une image reprsentant H(x,y) pour tout
pixel (x,y).
*/

image Harris(char* fichier,int diametre,int imin,int imax,int jmin, int jmax)
{
//On charge l'image dans une fentre deux fois plus grande.
	image A(fichier);

	int h=A.height();
	int w=A.width();
	A.display();
	//Click();
    
    dimage Imaj=A;
	Imaj.display(w,0);
	//Click();

	dimage DX=Imaj.deriche(1,0,0);
	DX.display(w,0);
	//Click();

	dimage DY=Imaj.deriche(0,1,0);
	DY.display(w,0);
	//Click();

/*
On calcule les valeurs de A (DDX), B(DDY) et C(DXDY) sur l'image
*/
	image DDY(w,h);
	image DDX(w,h);
	image DXDY(w,h);
	double tempX,tempY,tempXY;
	for (int i=0;i<w;i++)
	{
		for	(int j=0;j<h;j++)
		{
			tempX=(DX(i,j))/256;
			tempY=(DY(i,j))/256;
			DDY(i,j)=byte (256 * (tempY*tempY)) ;
	     	DDX(i,j)=byte (256 * (tempX*tempX)) ;
			DXDY(i,j)=byte (256 * (tempX*tempY));
		}
	}
	
/*
On lisse A(DDX) B(DDY) et C(DXDY) pour obtenir respectivement DDDX, DDDY, DDDXY.
*/
	//!! Apparemment on doit dupliquer l'image avant d'appliquer
	//deriche, sinon on a l'erreur : 'deriche': n'est pas membre de 'image'...???
	dimage DXYTemp=DXDY;
	dimage DDDXY=DXYTemp.deriche(0,0,0.3);	
	dimage DXTemp=DDX;
	dimage DDDX=DXTemp.deriche(0,0,0.3);	
	dimage DYTemp=DDY;
	dimage DDDY=DYTemp.deriche(0,0,0.3);	
	
	DDY.display();
	DDDY.display(w,0);
	//Click();

	DDX.display();
	DDDX.display(w,0);
	//Click();

	DXDY.display();
	DDDXY.display(w,0);
	//Click();

	
/*
On va afficher HH en convertissant HH(x,y) en intensit lumineuse associe.
C'est pourquoi, lors du calcul de HH, on garde en mmoire le max et le min
des valeurs rencontres
*/
	image HH(w,h);

	double min=0;
	double max=0;
	double tempdouble;
	for (int i=0;i<w;i++)
	{
		for	(int j=0;j<h;j++)
		{
			tempX=(DDDX(i,j))/256;
			tempY=(DDDY(i,j))/256;
			tempXY=(DDDXY(i,j))/256;
			tempdouble = (tempX*tempY-tempXY*tempXY)-0,04*(tempX+tempY);
	
			if (tempdouble<min)
				min=tempdouble;
			if (tempdouble>max)
				max=tempdouble;
		}
	}
	cout << "max : " << max <<" ";
	cout << "min : " << min <<" ";
	cout << endl;
	
//On calcule l'image associe  HH...
	for (int i=0;i<w;i++)
	{
		for	(int j=0;j<h;j++)
		{
			tempX=(DDDX(i,j))/256;
			tempY=(DDDY(i,j))/256;
			tempXY=(DDDXY(i,j))/256;
			HH(i,j)=byte (255*   (tempX*tempY-tempXY*tempXY-0,04*(tempX+tempY))/(max-min)) ;
		}
	}
	
//... Et on l'affiche
	cout << "Affichage de H" <<endl;
	HH.display();
//	Click();


/*
Pour trouver les maximas locaux de H, on prend une grille et
on les cherche dans chaque case d'un certain diamtre dfini
en fonction des dimensions de l'image.
*/
	image MaxLoc(2*w,h);
	diametre;
	int itrouve;
	int jtrouve;
	int htrouve;
	for (int i=0;i<w;i=i+diametre)
	{
		for	(int j=0;j<h;j=j+diametre)
		{
			itrouve=i;
			jtrouve=j;
			htrouve=HH(i,j);
			for (int ii=0;(ii<diametre) && (i+ii<w);ii++)
			{
				for	(int jj=0;(jj<diametre) && (j+jj<h);jj++)
				{
					if (HH(i+ii,j+jj)>htrouve)
					{
						MaxLoc(itrouve,jtrouve)=0;
						MaxLoc(i+ii,j+jj)=255;
						htrouve=HH(i+ii,j+jj);
						itrouve=i+ii;
						jtrouve=j+jj;
					}
					else
						MaxLoc(i+ii,j+jj)=0;
					if ((i+ii>imax) || (i+ii<imin) || (j+jj>jmax) || (j+jj<jmin))
						MaxLoc(i+ii,j+jj)=0;
				}
			}

		}
	}

	MaxLoc.display(w,0);
//	Click();


/*
On refait la mme chose en dcalant la grille
*/

min=255;
max=0;
int nombrepoints=0;

	for (int i=(int) (diametre/2);i<w;i=i+diametre)
	{
		for	(int j=(int) (diametre/2);j<h;j=j+diametre)
		{
			itrouve=i;
			jtrouve=j;
			htrouve=0;
			for (int ii=0;(ii<diametre) && (i+ii<w);ii++)
			{
				for	(int jj=0;(jj<diametre) && (j+jj<h);jj++)
				{
				if (MaxLoc(i+ii,j+jj)>0)
				{
					if (HH(i+ii,j+jj)>htrouve)
						{
							MaxLoc(itrouve,jtrouve)=0;
							MaxLoc(i+ii,j+jj)=255;
							htrouve=HH(i+ii,j+jj);
							itrouve=i+ii;
							jtrouve=j+jj;
						}
						else
							MaxLoc(i+ii,j+jj)=0;
					if ((i+ii>imax) || (i+ii<imin) || (j+jj>jmax) || (j+jj<jmin))
						MaxLoc(i+ii,j+jj)=0;
					}
				}
			}
			if (htrouve>0)
				nombrepoints++;

		if ((htrouve>0) && (htrouve<min))
			min=htrouve;
		if (htrouve>max)
			max=htrouve;
		}
	}

	MaxLoc.display(w,0);
	cout << "Nombre de points trouves : " << nombrepoints << endl;
//	Click();


/*
On a donc MaxLoc gal  1 pour tous les coins trouvs, 0 sinon.

Ci dessous, on rduit le nombre de points trouvs en en prenant environ
nbharris, de valeur maximale.
*/

	int seuil=127;
	int precision=64;
	while (precision>1)
	{
		//On ne doit pas prendre de points trop prs des bords.
		nombrepoints=0;
		int rayon=(int) diametre/2;
		for (int i=rayon;i<w-rayon;i++)
		{
		for	(int j=rayon;j<h-rayon;j++)
		{
			if (MaxLoc(i,j)==255)
			{
				if (HH(i,j)>=seuil)
					nombrepoints++;
			}
		}
		}
		if (nombrepoints>nbharris)
            seuil=seuil+precision;
		else
			seuil=seuil-precision;
		precision=precision/2;
	}
	cout << "Seuil : " << seuil << endl;
	cout << "Nombre de points finalement : " << nombrepoints << endl;
    int rayon=(int) (diametre/2);
	for (int i=0;i<w;i++)
	{
		for	(int j=0;j<h;j++)
		{
			if (MaxLoc(i,j)==255)
			{
			if (HH(i,j)>=seuil)
			{
				if ((i>=rayon) && (i<w-rayon) && (j>=rayon) && (j<h-rayon))
					MaxLoc(i,j)=255;
				else
					MaxLoc(i,j)=0;
			}
			else
				MaxLoc(i,j)=0;
			}				
		}
	}

	for (int i=0;i<w;i++)
	{
		for	(int j=0;j<h;j++)
		{
			MaxLoc(w+i,j)=HH(i,j);
		}
	}

	MaxLoc.display(w,0);
//	Click();


//return HH;
return MaxLoc;
}



/*
Les 4 fonctions suivantes sont dfinies dans la partie Corrlation de l'nonc.
*/

//On a pris nos prcautions avant pour que la fentre autour du
//point (x,y) soit entirement  l'intrieur de l'image.
double Moyenne(int x,int y,int rayon,image imaj)
{
	double temp=0;
	double moyen=0;
	for (int i=x-rayon;i<=x+rayon;i++)
	{
		for	(int j=y-rayon;j<=y+rayon;j++)
		{
			temp=((double) imaj(i,j))/256;
			moyen=(moyen+temp);
		}
	}
	//cout << "Scalaire : "<< moyen<< endl;
	return (moyen/((2*rayon+1)*(2*rayon+1)));
}

double Scalaire(int xa,int ya,int xb,int yb,int rayon,image imaj1,image imaj2)
{
	double moyen=0;
	double temp=0;
	for (int u=-rayon;u<=rayon;u++)
	{
		for	(int v=-rayon;v<=rayon;v++)
		{
			//cout << "Scalaire : "<< temp <<"|"<< -Moyenne(xa,ya,rayon,imaj1)<<"|"<<-Moyenne(xb,yb,rayon,imaj2)<< endl;
			moyen= (moyen+ (((double) imaj1(xa+u,ya+v)) /256 - Moyenne(xa,ya,rayon,imaj1)) *  (((double) imaj2(xb+u,yb+v)) /256 - Moyenne(xb,yb,rayon,imaj2))) ;
		}
	}
	return (moyen/((2*rayon+1)*(2*rayon+1)));
}

double Norme(int x,int y,int rayon,image imaj)
{
return sqrt(Scalaire(x,y,x,y,rayon,imaj,imaj));
}

double LaNorme(int x,int y)
{
return sqrt((double) (x*x+y*y));
}


double CorrelCroisee(int xa,int ya,int xb,int yb,int rayon,image imaj1,image imaj2)
{
	//cout << "Correlation(" << Scalaire(xa,ya,xb,yb,rayon,imaj1,imaj2) << "_" <<Norme(xa,ya,rayon,imaj1)<< "_" <<Norme(xb,yb,rayon,imaj2) <<endl;
			//Click();
	return (Scalaire(xa,ya,xb,yb,rayon,imaj1,imaj2)/(Norme(xa,ya,rayon,imaj1)*Norme(xb,yb,rayon,imaj2)));
}

/*
Corrlation :

Prend en entre deux images sorties de la fonction Harris,
et stocke dans le tableau tab quatre paires de points de
Harris qui correspondent.
*/
void Correlation(image h1,image h2,image pic1, image pic2,int rayon,double* Z, double* T, double*X, double* Y)
{
double correlation[N];
double ZZ[1000];
double TT[1000];
double XX[1000];
double YY[1000];
int w=pic1.width();
int h=pic1.height();
int pointstrouves1=0;
	for (int i=0;i<w;i++)
	{
		for	(int j=0;j<h;j++)
		{
			if (h1(i,j)==255)
			{
				XX[pointstrouves1]=i;
				YY[pointstrouves1]=j;
				pointstrouves1++;
			}
		}
	}

int pointstrouves2=0;
	for (int i=0;i<w;i++)
	{
		for	(int j=0;j<h;j++)
		{
			if (h2(i,j)==255)
			{
				ZZ[pointstrouves2]=i;
				TT[pointstrouves2]=j;
				pointstrouves2++;
			}
		}
	}

//cout << ZZ[pointstrouves2-1]<<","<<TT[pointstrouves2-1] <<endl;
for (int i=0;i<N;i++)
{
	correlation[i]=-1;
}

double pourcent=0;
double correltrouvee=0;
double meilleurelocale;
double mincorrel=-1;
int compteur, trouve, meilleurj;
for (int i=0;i<pointstrouves1;i++)
	{
		meilleurelocale=-1;
		for	(int j=0;j<pointstrouves2;j++)
		{
			correltrouvee=CorrelCroisee(XX[i],YY[i],ZZ[j],TT[j],rayon,pic1,pic2);
			if (correltrouvee>meilleurelocale)
			{
				meilleurelocale=correltrouvee;
				meilleurj=j;
			}
		}
		correltrouvee=meilleurelocale;
		if (correltrouvee>mincorrel)
		{
			//cout <<mincorrel<< "MIEUX"<<correltrouvee<<"("<<X[i]<< ","<< Y[i]<< ")"<< "("<<Z[i]<< ","<< T[i]<< ")"<<endl;
			compteur=0;
			trouve=0;
			while ((compteur<N) && (trouve==0))
			{			
				if (correlation[compteur]==mincorrel)
				{
					correlation[compteur]=correltrouvee;
					Z[compteur]=ZZ[meilleurj];
					T[compteur]=TT[meilleurj];
					X[compteur]=XX[i];
					Y[compteur]=YY[i];
					trouve=1;
					//cout << i<< "("<<X[i]<< ","<< Y[i]<< ")"<< "("<<Z[i]<< ","<< T[i]<< ")"<<endl;
				}
				mincorrel=correltrouvee;
				compteur++;
			
				for (int i=0;i<N;i++)
				{
					if (correlation[i]<mincorrel)
						mincorrel=correlation[i];
				}
			}
	//		cout << "Correlation("<<i <<","<<j<<") : "<<correltrouvee << endl;
		}

		if ((((double) i)/pointstrouves1)>pourcent+0.1)
		{
			pourcent=(((double) i)/pointstrouves1);
			cout <<"Correlation : "<< ((int) (pourcent*10))*10 << "%"<<endl;
		}
	}


	cout << "Meilleurs points de Harris trouves :"<<endl;
for (int i=0;i<N;i++)
{
	h1((int) X[i]+1,(int) Y[i]+1)=255;
	h1((int) X[i]-1,(int) Y[i]+1)=255;
	h1((int) X[i]-1,(int) Y[i]-1)=255;
	h1((int) X[i]+1,(int) Y[i]-1)=255;
	h1((int) X[i],(int) Y[i]-1)=255;
	h1((int) X[i],(int) Y[i]+1)=255;
	h1((int) X[i]-1,(int) Y[i])=255;
	h1((int) X[i]+1,(int) Y[i])=255;
	
	h2((int) Z[i]+1,(int) T[i]+1)=255;
	h2((int) Z[i]-1,(int) T[i]+1)=255;
	h2((int) Z[i]-1,(int) T[i]-1)=255;
	h2((int) Z[i]+1,(int) T[i]-1)=255;
	h2((int) Z[i],(int) T[i]-1)=255;
	h2((int) Z[i],(int) T[i]+1)=255;
	h2((int) Z[i]-1,(int) T[i])=255;
	h2((int) Z[i]+1,(int) T[i])=255;
	
	cout << "Image1("<<X[i]<< ","<< Y[i]<< ") - Image2("<<Z[i]<< ","<< T[i]<< ")"<<endl;
h1.display();
h2.display(pic1.width(),0);
Click();

}


//		(Z,T)=H(X,Y).
//	Z T X Y. (x2 y2 x1 y1) avec N=



}



//=======================================================
// Estimator pour H avec 4 paires de points.
//(X2,Y2)=H(X1,Y1)
//(X4,Y4)=H(X3,Y3)
//(X6,Y6)=H(X5,Y5)
//(X8,Y8)=H(X7,Y7)

int estimatorH(double params[], /* output: estimated parameter vector */
			   int nb, /* input: number of data to be used */
			   const int indexes[] /* input: indexes of data to be used */
	      )	
{
	if (nb!=4)
		return 0;
	double x1=X[indexes[0]],y1=Y[indexes[0]];
	double x2=Z[indexes[0]],y2=T[indexes[0]];
	double x3=X[indexes[1]],y3=Y[indexes[1]];
	double x4=Z[indexes[1]],y4=T[indexes[1]];
	double x5=X[indexes[2]],y5=Y[indexes[2]];
	double x6=Z[indexes[2]],y6=T[indexes[2]];
	double x7=X[indexes[3]],y7=Y[indexes[3]];
	double x8=Z[indexes[3]],y8=T[indexes[3]];
	//On pourrait utiliser des tableaux, mais ca sera plus lisible ainsi par la suite

	//inclure peut-tre ici une liste de tests de divisibilit...
	if (x1=x3) return 0; //On pourrait dans ce cas biaiser en prenant x1-x5, etc...

	// Calcul de h7, totaux intermdiaires...
	double D1=(y1-y3)*(x1-x5)-(y1-y5)*(x1-x3);
	double D2=(y1-y3)*(x1-x7)-(y1-y7)*(x1-x3);
	double T1=((y1*x2-y3*x4)*(x1-x7)-(y1*x2-y7*x8)*(x1-x3))/D2 -((y1*x2-y3*x4)*(x1-x5)-(y1*x2-y5*x6)*(x1-x3))/D1;
	double T2=((x2-x4)*(x1-x7)-(x2-x8)*(x1-x3))/D2 -((x2-x4)*(x1-x5)-(x2-x6)*(x1-x3))/D1;
	double T3=((x1*x2-x3*x4)*(x1-x5)-(x1*x2-x5*x6)*(x1-x3))/D1 -((x1*x2-x3*x4)*(x1-x7)-(x1*x2-x7*x8)*(x1-x3))/D2;

	double T4=((y1*y2-y3*y4)*(x1-x7)-(y1*y2-y7*y8)*(x1-x3))/D2 -((y1*y2-y3*y4)*(x1-x5)-(y1*y2-y5*y6)*(x1-x3))/D1;
	double T5=((y2-y4)*(x1-x7)-(y2-y8)*(x1-x3))/D2 -((y2-y4)*(x1-x5)-(y2-y6)*(x1-x3))/D1;
	double T6=((x1*y2-x3*y4)*(x1-x5)-(x1*y2-x5*y6)*(x1-x3))/D1 -((x1*y2-x3*y4)*(x1-x7)-(x1*y2-x7*y8)*(x1-x3))/D2;
	// Correspond  h6*T3=h7*T1+T2

	params[7]=(T5/T6-T2/T3)/(T1/T3-T4/T6);
	// Plus qu' tout rcup...
	params[6]=(params[7]*T1+T2)/T3;
	double P1=params[6]*x1+params[7]*y1+1;
	double P3=params[6]*x3+params[7]*y3+1;
	double P5=params[6]*x5+params[7]*y5+1;
	params[1]=((P1*x2-P3*x4)*(x1-x5)-(P1*x2-P5*x6)*(x1-x3))/D1;
	params[4]=((P1*y2-P3*y4)*(x1-x5)-(P1*y2-P5*y6)*(x1-x3))/D1;
	params[0]=(P1*x2-P3*x4-params[1]*(y1-y3))/(x1-x3);
	params[3]=(P1*y2-P3*x4-params[4]*(y1-y3))/(x1-x3);
	params[2]=P1*x2-params[0]*x1-params[1]*y1;
	params[5]=P1*y2-params[3]*x1-params[4]*y1;
	return 1; //Yeepee!
}


// Erreurs au carr quand on prend params
void residualH(const double params[], /* input: parameter vector */
			   int nb, /* input: number of residuals to be computed */
			   const int indexes[], /* input: indexes of data to be used */
			   double resid[] /* output: computed residuals */
	      )		
{
	for (int i=0;i<nb;i++) {
		double err1=Z[indexes[i]]-(params[0]*X[indexes[i]]+params[1]*Y[indexes[i]]+params[3])/(params[6]*X[indexes[i]]+params[7]*Y[indexes[i]]+1);
		double err2=T[indexes[i]]-(params[3]*X[indexes[i]]+params[4]*Y[indexes[i]]+params[5])/(params[6]*X[indexes[i]]+params[7]*Y[indexes[i]]+1);
		resid[i]=err1*err1+err2*err2;
	}
}
//=======================================================




int main()
{
	// Lecture de l'image pour avoir la bonne taille et ouvrir la fentre adapte.
	
	char * fichier1;
	char * fichier2;
	
	///* 
	fichier1="../Data/Mosaic/Cannes/miniimage00003.jpg";
	fichier2="../Data/Mosaic/Cannes/miniimage00004.jpg";
	//*/

	/* 
	fichier1="../Data/Mosaic/Cannes/image0001.jpg";
	fichier2="../Data/Mosaic/Cannes/image0002.jpg";
	*/ 

	/*
	fichier1="../Data/Mosaic/MPrague1.jpg";
	fichier2="../Data/Mosaic/MPrague2.jpg";
	*/

	image A(fichier1);
	OpenWindow(2*A.width(),A.height());
	
	int diametre=Diam;

	//On cherche les points de Harris dans la partie droite de l'image 1
	image pict1=Harris(fichier1,diametre,(int) (A.width()/2),A.width(),0,A.height());
	
	//On cherche les points de Harris dans la partie droite de l'image 2
	image pict2=Harris(fichier2,diametre,0,(int) (A.width()/2),0,A.height());
	
	pict1.display();
	pict2.display(A.width(),0);
	
	Click();

	int rayon= (int) (diametre/2);
	//int rayon=4;
	image imaj1(fichier1);
	image imaj2(fichier2);
	Correlation(pict1,pict2,imaj1,imaj2,rayon,Z,T,X,Y);

//		(Z,T)=H(X,Y).
//	Z T X Y. (x2 y2 x1 y1) avec N=

	
	//image A("../Data/Mosaic/Cannes/image0001.jpg");
	//image A("../Data/h.gif");
	//image A("../Data/ppd.jpg");

		

/*
LMS plante avec les paramtres suivants. On va donc utiliser une mthode alternative.

	// Parametres a estimer
	int nbPar=8; // on cherche H...
	double params[8];

	// Avec combien de mesures on peut estimer les parametres
	int nbSamp=4;

	// indices des outliers
	int outliers[N];
	int nbOutliers;*/

//	int ret=LMedS(N,	/* input: the number of Data, which is ordered from 0 */
//					nbSamp,	/* input: size of each randomly selected subset of data */
//					0,		/* input: randomly selected subsets, can be set to NULL,
//							* then a default routine will be used to generate the subsets */
//					0,		  /* input: the number of subsets, not used if sets == NULL */
//					residualH, /* input: function which calculates the residuals */
//					estimatorH,
//					1, /* input: set 1 if `residual' computes the squared residuals */
//					1,	/* input: verbose mode */
//					1,	/* input: maximum number of solutions given by "estimator" */
//					3,	/* input: gate value for outlier detection, a value in [2, 4] */
//					0,	/* input: if > 0.0, LMedS stops when a subset gives a median
//							* residual less than `prematureResidual'.
//							* The specified value must be in accordance with `residual' */
//					nbPar,	/* input: dimension of the parameter vector */
//					.5, /* input: the percentage
//						(between epsilon and 1.0) of good data. An appropriate
//								choice is often 0.5 */
//					params,	/* output: the corresponding estimate of parameters */
//					0,		/* output: best subset retained, can be set to NULL */
//					outliers,	/* output: the outliers detected by LMedS */
//					&nbOutliers	/* output: the number of detected outliers */
  //  );
/*
	if (!ret) {
		cout << "erreur " << ret << endl;
		return 1;
	}
	for (int i=0;i<nbPar;i++)
		cout << "param[" << i << "]=" << params[i] << endl;
	cout << "outliers: ";
	for (int i=0;i<nbOutliers;i++)
		cout << outliers[i] << " ";
	cout << endl;
	return 0;
	Click();
*/


/*
Algo alternatif  la mthode de LMS et de l'homographie pour reconstruire la mosaque :
On slectionne tout d'abord, parmi les 8 meilleurs paires trouves par la mthode
de corrlation, celles qui correspondent le mieux dans les deux images par la mthode
suivante :
On prend trois paires de points : (x1,y1)(x'1,y'1) (x2,y2)(x'2,y'2) (x3,y3)(x'3,y'3).
On exprime les 5 paires restantes de points dans la base ((x2-x1,y2-y1),(x3-x1,y3-y1)).
On obtient alors des coordonnes thoriques de ces 5 points dans la base :
((x'2-x'1,y'2-y'1),(x'3-x'1,y'3-y'1)). On calcule un cout de diffrence entre les coordonnes
thoriques et les coordonnes trouves. Ainsi, pour chaque triplet de paires de points,
on a un cout. Le triplet de cout le plus petit est slectionn. C'est lui qui servira
de base pour reconstruire l'image.
*/


//On sauvegarde les 2 images de dpart.
dimage orig1= imaj1;
dimage orig2 =imaj2;

int x1,ax2,ax3,ax4,y1,ay2,ay3,ay4,dax4,day4;
int besti,bestj,bestk;
double lecoutmin=10000;
double lecout,k1,k2;
double coutpoint[8];

for (int i=0;i<N;i++)
{
	coutpoint[i]=0;		
	x1=X[1];
	y1=Y[1];	
	for (int j=0;j<N;j++)
	{
		ax2=(X[j]-x1);
		ay2=(Y[j]-y1);
		if (j!=i)
		{
		for (int k=0;k<N;k++)
		{
			ax3=(X[k]-x1);
			ay3=(Y[k]-y1);
			if ((k!=i) && (k!=j))
			{
			lecout=0;
			for (int l=0;l<N;l++)
			{
				if ((l!=i) && (l!=j) && (l!=k))
				{
					ax4=(X[l]-x1);
					ay4=(Y[l]-y1);
					//Coordonnes de x4 dans la base ((x1,x2),(x1,x3)) :
					k2=((double) (ax2*ay4-ay2*ax4))/(ax2*ay3-ay2*ax3);
					k1=((double) (ax3*ay4-ay3*ax4))/(ax3*ay2-ay3*ax2);
					//Coordonnes du vecteur diffrence entre le point attendu
					//et le point trouv correspondant  x4,y4 dans l'image 2.
					dax4=Z[l]-Z[i]-(k1*(Z[k]-Z[i]));
					day4=T[l]-T[i]-(k2*(T[k]-T[i]));
					lecout=lecout + sqrt((double) (dax4*dax4+day4*day4));
				}
			}
			//cout <<"Norme"<< (LaNorme(ax3-ax2,ay3-ay2)/LaNorme(ax3,ay3)) <<endl;
			if ((lecout<lecoutmin) && (ax2>2*diametre) && (ax3>2*diametre)&& (ay2>2*diametre) && (ay3>2*diametre) && (LaNorme(ax3-ax2,ay3-ay2)/LaNorme(ax3,ay3)>0.4))
			{
				lecoutmin=lecout;
				besti=i;
				bestj=j;
				bestk=k;
			}


	
	//		cout << "Cout ("<<i<<";"<<j<<";"<<k<<") : "<<lecout<<endl;
			coutpoint[i]=coutpoint[i]+lecout;
			}
		}
		}
	}
}

for (int i=0;i<(imaj1.width());i++)
{
	for (int j=0;j<(imaj1.height());j++)
	{
		pict1(i,j)=0;
		pict2(i,j)=0;
	}
}


	pict1((int) X[besti],(int) Y[besti])=255;
	pict1((int) X[bestj],(int) Y[bestj])=255;
	pict1((int) X[bestk],(int) Y[bestk])=255;
	pict2((int) Z[besti],(int) T[besti])=255;
	pict2((int) Z[bestj],(int) T[bestj])=255;
	pict2((int) Z[bestk],(int) T[bestk])=255;
	pict1.display();
	pict2.display(A.width(),0);

cout << "Cout minimal ("<<besti<<"("<<X[besti]<<","<<Y[besti]<<") "<<";"<<bestj<<"("<<X[bestj]<<","<<Y[bestj]<<") "<<";"<<"("<<X[bestk]<<","<<Y[bestk]<<") "<<bestk<<") : "<<lecoutmin<<endl;
cout << "Cout minimal ("<<besti<<"("<<Z[besti]<<","<<T[besti]<<") "<<";"<<bestj<<"("<<Z[bestj]<<","<<T[bestj]<<") "<<";"<<"("<<Z[bestk]<<","<<T[bestk]<<") "<<bestk<<")";

Click();

imaj1.display();
int ax,ay;
double iimaj2,jimaj2;
x1=X[besti];
y1=Y[besti];
ax2=X[bestj]-X[besti];
ay2=Y[bestj]-Y[besti];
ax3=X[bestk]-X[besti];
ay3=Y[bestk]-Y[besti];

for (int i=0;i<(imaj1.width());i++)
{
	for (int j=0;j<(imaj1.height());j++)
	{
		ax=i+imaj1.width()-X[besti];
		ay=j-Y[besti];
		k2=((double) (ax2*ay-ay2*ax))/(ax2*ay3-ay2*ax3);
		k1=((double) (ax3*ay-ay3*ax))/(ax3*ay2-ay3*ax2);
		iimaj2=Z[besti]+k1*(Z[bestj]-Z[besti])+k2*(Z[bestk]-Z[besti]);
		//Click();
		jimaj2=T[besti]+k1*(T[bestj]-T[besti])+k2*(T[bestk]-T[besti]);

		if ((iimaj2<imaj2.width()) && (jimaj2<imaj2.height()) && (iimaj2>=0) && (jimaj2>=0))
		{		
			imaj1(i,j)=imaj2((int) iimaj2,(int) jimaj2);
		}
		else
			imaj1(i,j)=0;
	}
}

imaj1.display(imaj1.width(),0);

Click();
	Terminate();
	return 0;
}
