
// ===================== SCHEMA D'UTILISATION =================
// (pas un exemple complet!)

#include <iostream>
using namespace std;

#include "../Images/tools.h"
#include "../Images/lmeds.h"

// Variable globales (pour etre vues de estimator et residual)
// Vieux style C!
const int N=100;
double X[N],Y[N],Z[N],T[N];

//=======================================================
// Exemple estimation d'une droite
/* input: function which calculates the residuals */

/* function which estimate the parameters
 * returns 0 if problem */
int estimator(double params[], /* output: estimated parameter vector */
			   int nb, /* input: number of data to be used */
			   const int indexes[] /* input: indexes of data to be used */
	      )	
{
	if (nb!=2)
		return 0;
	double x1=X[indexes[0]],y1=Y[indexes[0]];
	double x2=X[indexes[1]],y2=Y[indexes[1]];
	if (x1==x2)
		return 0; // impossible
	params[1]=(y2-y1)/(x2-x1);
	params[0]=y1-x1*params[1];
	return 1;
}
// Erreurs au carr quand on prend params
void residual(const double params[], /* input: parameter vector */
			   int nb, /* input: number of residuals to be computed */
			   const int indexes[], /* input: indexes of data to be used */
			   double resid[] /* output: computed residuals */
	      )		
{
	for (int i=0;i<nb;i++) {
		double err=Y[indexes[i]]-params[1]*X[indexes[i]]-params[0];
		resid[i]=err*err;
	}
}
//=======================================================





//=======================================================
// Estimator pour H avec 4 paires de points.
//(X2,Y2)=H(X1,Y1)
//(X4,Y4)=H(X3,Y3)
//(X6,Y6)=H(X5,Y5)
//(X8,Y8)=H(X7,Y7)

int estimatorH(double params[], /* output: estimated parameter vector */
			   int nb, /* input: number of data to be used */
			   const int indexes[] /* input: indexes of data to be used */
	      )	
{
	if (nb!=4)
		return 0;
	double x1=X[indexes[0]],y1=Y[indexes[0]];
	double x2=Z[indexes[0]],y2=T[indexes[0]];
	double x3=X[indexes[1]],y3=Y[indexes[1]];
	double x4=Z[indexes[1]],y4=T[indexes[1]];
	double x5=X[indexes[2]],y5=Y[indexes[2]];
	double x6=Z[indexes[2]],y6=T[indexes[2]];
	double x7=X[indexes[3]],y7=Y[indexes[3]];
	double x8=Z[indexes[3]],y8=T[indexes[3]];
	//On pourrait utiliser des tableaux, mais ca sera plus lisible ainsi par la suite

	//inclure ici une liste de test de divisibilit... A DETERMINER !
	if (x1=x3) return 0; //On pourrais dans ce cas biaiser en prenant x1-x5, etc...

	// Calcul de h7, totaux intermdiaires...
	double D1=(y1-y3)*(x1-x5)-(y1-y5)*(x1-x3);
	double D2=(y1-y3)*(x1-x7)-(y1-y7)*(x1-x3);
	double T1=((y1*x2-y3*x4)*(x1-x7)-(y1*x2-y7*x8)*(x1-x3))/D2 -((y1*x2-y3*x4)*(x1-x5)-(y1*x2-y5*x6)*(x1-x3))/D1;
	double T2=((x2-x4)*(x1-x7)-(x2-x8)*(x1-x3))/D2 -((x2-x4)*(x1-x5)-(x2-x6)*(x1-x3))/D1;
	double T3=((x1*x2-x3*x4)*(x1-x5)-(x1*x2-x5*x6)*(x1-x3))/D1 -((x1*x2-x3*x4)*(x1-x7)-(x1*x2-x7*x8)*(x1-x3))/D2;

	double T4=((y1*y2-y3*y4)*(x1-x7)-(y1*y2-y7*y8)*(x1-x3))/D2 -((y1*y2-y3*y4)*(x1-x5)-(y1*y2-y5*y6)*(x1-x3))/D1;
	double T5=((y2-y4)*(x1-x7)-(y2-y8)*(x1-x3))/D2 -((y2-y4)*(x1-x5)-(y2-y6)*(x1-x3))/D1;
	double T6=((x1*y2-x3*y4)*(x1-x5)-(x1*y2-x5*y6)*(x1-x3))/D1 -((x1*y2-x3*y4)*(x1-x7)-(x1*y2-x7*y8)*(x1-x3))/D2;
	// Aurait pu etre gnr par une fonction...
	// Correspond  h6*T3=h7*T1+T2

	params[7]=(T5/T6-T2/T3)/(T1/T3-T4/T6);
	// Plus qu' tout rcup...
	params[6]=(params[7]*T1+T2)/T3;
	double P1=params[6]*x1+params[7]*y1+1;
	double P3=params[6]*x3+params[7]*y3+1;
	double P5=params[6]*x5+params[7]*y5+1;
	params[1]=((P1*x2-P3*x4)*(x1-x5)-(P1*x2-P5*x6)*(x1-x3))/D1;
	params[4]=((P1*y2-P3*y4)*(x1-x5)-(P1*y2-P5*y6)*(x1-x3))/D1;
	params[0]=(P1*x2-P3*x4-params[1]*(y1-y3))/(x1-x3);
	params[3]=(P1*y2-P3*x4-params[4]*(y1-y3))/(x1-x3);
	params[2]=P1*x2-params[0]*x1-params[1]*y1;
	params[5]=P1*y2-params[3]*x1-params[4]*y1;
	return 1; //Yeepee!
	//Formules obtenues  la main,  vrifier encore...
}


// Erreurs au carr quand on prend params
void residualH(const double params[], /* input: parameter vector */
			   int nb, /* input: number of residuals to be computed */
			   const int indexes[], /* input: indexes of data to be used */
			   double resid[] /* output: computed residuals */
	      )		
{
	for (int i=0;i<nb;i++) {
		double err1=Z[indexes[i]]-(params[0]*X[indexes[i]]+params[1]*Y[indexes[i]]+params[3])/(params[6]*X[indexes[i]]+params[7]*Y[indexes[i]]+1);
		double err2=T[indexes[i]]-(params[3]*X[indexes[i]]+params[4]*Y[indexes[i]]+params[5])/(params[6]*X[indexes[i]]+params[7]*Y[indexes[i]]+1);
		resid[i]=err1*err1+err2*err2;
	}
}
//=======================================================
// Reste  modifier main, pour inclure H, 8params, nb=8, etc...


int main()
{
//Refaire ce truc ci dessous pour Z T X Y. (x2 y2 x1 y1) avec N=8
	/*for (int i=0;i<N;i++) {
		X[i]=i;
		if (!(i%10))
			Y[i]=0; // un outlier tous les 10
		else
			Y[i]=2*X[i]+3+gaussienne()*.25; // 2x+3+bruit
	} */

//Il faut ici assigner les points de harris, tel que (Z,T)=H(X,Y).

	// Parametres a estimer
	int nbPar=8; // on cherche H...
	double params[8];

	// Avec combien de mesures on peut estimer les parametres
	int nbSamp=4;

	// indices des outliers
	int outliers[N];
	int nbOutliers;

	int ret=LMedS(N,	/* input: the number of Data, which is ordered from 0 */
					nbSamp,	/* input: size of each randomly selected subset of data */
					0,		/* input: randomly selected subsets, can be set to NULL,
							* then a default routine will be used to generate the subsets */
					0,		  /* input: the number of subsets, not used if sets == NULL */
					residualH, /* input: function which calculates the residuals */
					estimatorH,
					1, /* input: set 1 if `residual' computes the squared residuals */
					0,	/* input: verbose mode */
					1,	/* input: maximum number of solutions given by "estimator" */
					3,	/* input: gate value for outlier detection, a value in [2, 4] */
					0,	/* input: if > 0.0, LMedS stops when a subset gives a median
							* residual less than `prematureResidual'.
							* The specified value must be in accordance with `residual' */
					nbPar,	/* input: dimension of the parameter vector */
					.5, /* input: the percentage
						(between epsilon and 1.0) of good data. An appropriate
								choice is often 0.5 */
					params,	/* output: the corresponding estimate of parameters */
					0,		/* output: best subset retained, can be set to NULL */
					outliers,	/* output: the outliers detected by LMedS */
					&nbOutliers	/* output: the number of detected outliers */
    );

	if (!ret) {
		cout << "erreur " << ret << endl;
		return 1;
	}
	for (int i=0;i<nbPar;i++)
		cout << "param[" << i << "]=" << params[i] << endl;
	cout << "outliers: ";
	for (int i=0;i<nbOutliers;i++)
		cout << outliers[i] << " ";
	cout << endl;
	return 0;
}